# CreateCustomerCardRequest

### Description

Defines the fields that are included in the request body of a request to the CreateCustomerCard endpoint.

## Properties
Name | Getter | Setter | Type | Description | Notes
------------ | ------------- | ------------- | ------------- | ------------- | -------------
**card_nonce** | getCardNonce() | setCardNonce($value) | **string** | A card nonce representing the credit card to link to the customer.  Card nonces are generated by the Square Payment Form when customers enter their card information. See [Embedding the payment form](https://developer.squareup.com/docs/payment-form/payment-form-walkthrough) for more information.  __NOTE:__ Card nonces generated by digital wallets (e.g., Apple Pay) cannot be used to create a customer card. | 
**billing_address** | getBillingAddress() | setBillingAddress($value) | [**\SquareConnect\Model\Address**](Address.md) | Address information for the card on file. Only the &#x60;postal_code&#x60; field is required for payments in the US and Canada. | [optional] 
**cardholder_name** | getCardholderName() | setCardholderName($value) | **string** | The full name printed on the credit card. | [optional] 
**verification_token** | getVerificationToken() | setVerificationToken($value) | **string** | An identifying token generated by &#x60;SqPaymentForm.verifyBuyer()&#x60;. Verification tokens encapsulate customer device information and 3-D Secure challenge results to indicate that Square has verified the buyer identity. | [optional] 

Note: All properties are protected and only accessed via getters and setters.

[[Back to Model list]](../../README.md#documentation-for-models) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to README]](../../README.md)

