# ErrorCode

### Description

Indicates the specific error that occurred during a request to a Square API.

## Properties
Name | Type
------------ | -------------
**INTERNAL_SERVER_ERROR** | string
**UNAUTHORIZED** | string
**ACCESS_TOKEN_EXPIRED** | string
**ACCESS_TOKEN_REVOKED** | string
**CLIENT_DISABLED** | string
**FORBIDDEN** | string
**INSUFFICIENT_SCOPES** | string
**APPLICATION_DISABLED** | string
**V1_APPLICATION** | string
**V1_ACCESS_TOKEN** | string
**CARD_PROCESSING_NOT_ENABLED** | string
**BAD_REQUEST** | string
**MISSING_REQUIRED_PARAMETER** | string
**INCORRECT_TYPE** | string
**INVALID_TIME** | string
**INVALID_TIME_RANGE** | string
**INVALID_VALUE** | string
**INVALID_CURSOR** | string
**UNKNOWN_QUERY_PARAMETER** | string
**CONFLICTING_PARAMETERS** | string
**EXPECTED_JSON_BODY** | string
**INVALID_SORT_ORDER** | string
**VALUE_REGEX_MISMATCH** | string
**VALUE_TOO_SHORT** | string
**VALUE_TOO_LONG** | string
**VALUE_TOO_LOW** | string
**VALUE_TOO_HIGH** | string
**VALUE_EMPTY** | string
**ARRAY_LENGTH_TOO_LONG** | string
**ARRAY_LENGTH_TOO_SHORT** | string
**ARRAY_EMPTY** | string
**EXPECTED_BOOLEAN** | string
**EXPECTED_INTEGER** | string
**EXPECTED_FLOAT** | string
**EXPECTED_STRING** | string
**EXPECTED_OBJECT** | string
**EXPECTED_ARRAY** | string
**EXPECTED_MAP** | string
**EXPECTED_BASE64_ENCODED_BYTE_ARRAY** | string
**INVALID_ARRAY_VALUE** | string
**INVALID_ENUM_VALUE** | string
**INVALID_CONTENT_TYPE** | string
**INVALID_FORM_VALUE** | string
**ONE_INSTRUMENT_EXPECTED** | string
**NO_FIELDS_SET** | string
**CARD_EXPIRED** | string
**INVALID_EXPIRATION** | string
**INVALID_EXPIRATION_YEAR** | string
**INVALID_EXPIRATION_DATE** | string
**UNSUPPORTED_CARD_BRAND** | string
**UNSUPPORTED_ENTRY_METHOD** | string
**INVALID_ENCRYPTED_CARD** | string
**INVALID_CARD** | string
**GENERIC_DECLINE** | string
**CVV_FAILURE** | string
**ADDRESS_VERIFICATION_FAILURE** | string
**INVALID_ACCOUNT** | string
**CURRENCY_MISMATCH** | string
**INSUFFICIENT_FUNDS** | string
**INSUFFICIENT_PERMISSIONS** | string
**CARDHOLDER_INSUFFICIENT_PERMISSIONS** | string
**INVALID_LOCATION** | string
**TRANSACTION_LIMIT** | string
**VOICE_FAILURE** | string
**PAN_FAILURE** | string
**EXPIRATION_FAILURE** | string
**CARD_NOT_SUPPORTED** | string
**INVALID_PIN** | string
**INVALID_POSTAL_CODE** | string
**INVALID_FEES** | string
**MANUALLY_ENTERED_PAYMENT_NOT_SUPPORTED** | string
**PAYMENT_LIMIT_EXCEEDED** | string
**GIFT_CARD_AVAILABLE_AMOUNT** | string
**DELAYED_TRANSACTION_EXPIRED** | string
**DELAYED_TRANSACTION_CANCELED** | string
**DELAYED_TRANSACTION_CAPTURED** | string
**DELAYED_TRANSACTION_FAILED** | string
**CARD_TOKEN_EXPIRED** | string
**CARD_TOKEN_USED** | string
**AMOUNT_TOO_HIGH** | string
**UNSUPPORTED_INSTRUMENT_TYPE** | string
**REFUND_AMOUNT_INVALID** | string
**REFUND_ALREADY_PENDING** | string
**PAYMENT_NOT_REFUNDABLE** | string
**INVALID_CARD_DATA** | string
**LOCATION_MISMATCH** | string
**IDEMPOTENCY_KEY_REUSED** | string
**UNEXPECTED_VALUE** | string
**SANDBOX_NOT_SUPPORTED** | string
**INVALID_EMAIL_ADDRESS** | string
**INVALID_PHONE_NUMBER** | string
**CHECKOUT_EXPIRED** | string
**BAD_CERTIFICATE** | string
**INVALID_SQUARE_VERSION_FORMAT** | string
**API_VERSION_INCOMPATIBLE** | string
**CARD_DECLINED** | string
**VERIFY_CVV_FAILURE** | string
**VERIFY_AVS_FAILURE** | string
**CARD_DECLINED_CALL_ISSUER** | string
**CARD_DECLINED_VERIFICATION_REQUIRED** | string
**BAD_EXPIRATION** | string
**CHIP_INSERTION_REQUIRED** | string
**ALLOWABLE_PIN_TRIES_EXCEEDED** | string
**RESERVATION_DECLINED** | string
**NOT_FOUND** | string
**APPLE_PAYMENT_PROCESSING_CERTIFICATE_HASH_NOT_FOUND** | string
**METHOD_NOT_ALLOWED** | string
**NOT_ACCEPTABLE** | string
**REQUEST_TIMEOUT** | string
**CONFLICT** | string
**GONE** | string
**REQUEST_ENTITY_TOO_LARGE** | string
**UNSUPPORTED_MEDIA_TYPE** | string
**UNPROCESSABLE_ENTITY** | string
**RATE_LIMITED** | string
**NOT_IMPLEMENTED** | string
**BAD_GATEWAY** | string
**SERVICE_UNAVAILABLE** | string
**TEMPORARY_ERROR** | string
**GATEWAY_TIMEOUT** | string

Note: All properties are protected and only accessed via getters and setters.

[[Back to Model list]](../../README.md#documentation-for-models) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to README]](../../README.md)

